import Hist from "redoundo";
/**
 * Creates Proxy that calls `after` callback after set or delete entries of a `target`.
 *
 *
 * @param target target object
 * @param after callback to execute after set or delete entries of `target`
 */
export declare function make<T extends object>(target: T, after: () => void): T;
/**
 * Creates Proxy that calls `after` callback after set or delete entries of a `target`.
 * Set or delete actions can be (re, un)done using `redoundo.Hist` argument.
 *
 * @param target target object
 * @param after callback to execute after set or delete entries of `target`
 * @param hist `redoundo.Hist` object
 */
export declare function makeH<T extends object>(target: T, after: () => void, hist: Hist): T;
